/*
 * Copyright 2017 Huawei Technologies Co., Ltd
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.servicecomb.saga.core;

public interface SagaTask {

  String SAGA_START_TASK = "SagaStart";
  String SAGA_REQUEST_TASK = "SagaRequest";
  String SAGA_END_TASK = "SagaEnd";

  void commit(SagaRequest request);

  void compensate(SagaRequest request);

  void abort(SagaRequest request, Exception e);
}
